| IGLib 1.6.0 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Public Member Functions | Properties | List of all members
IG.Num.ScalarFunctionExamples.Quadratic2d Class Reference

Example quadratic polynomial in 2D. f(x,y) = 2*x^2 + y^2 + x*y + x + y + 10. More...

Inheritance diagram for IG.Num.ScalarFunctionExamples.Quadratic2d:
[legend]
Collaboration diagram for IG.Num.ScalarFunctionExamples.Quadratic2d:
[legend]

## Public Member Functions
| Quadratic2d ()
| Creates a new untransformed example quadratic polynomial in 2D. More...
| Quadratic2d (IAffineTransformation transf)
| Creates a new transformed example quadratic polynomial in 2D. Actual function is identical to the reference function applied to inverse transformed parameters. More...
override double | ReferenceValue (IVector parameters)
| Returns the value of this function at the specified parameter in the reference coordinate system. More...
override void | ReferenceGradientPlain (IVector parameters, IVector gradient)
| Calculates the first derivative (gradient) of this function at the specified parameter in the reference coordinate system. More...
override void | ReferenceHessianPlain (IVector parameters, IMatrix hessian)
| Calculates the second derivative (Hessian) of this function at the specified parameters in the reference coordinate system. More...
Public Member Functions inherited from IG.Num.ScalarFunctionBase
| ScalarFunctionBase (IAffineTransformation transf)
| Constructs a scalar function that is identical to some reference funciton acting on affine transformed parameters. More...
override double | Value (IVector x)
| Returns the value of this function at the specified parameter. More...
override void | GradientPlain (IVector x, IVector gradient)
| Returns the first derivative of this function at the specified parameter. More...
override void | HessianPlain (IVector x, IMatrix hessian)
| Returns the second derivative (Hessian) of this function at the specified arameter. More...
Public Member Functions inherited from IG.Num.ScalarFunctionUntransformedBase
virtual void | Evaluate (IScalarFunctionResults data)
| Evaluates whatever needs to be evaluated and stores the results on the specified storage object. More...
virtual void | Gradient (IVector parameters, ref IVector gradient)
| Calculates first order derivatives (gradient) of this function at the specified parameters. More...
virtual void | Hessian (IVector parameters, ref IMatrix hessian)
| Calculates the second derivative (Hessian matrix) of this function at the specified parameters. More...
virtual void | NumericalGradientForwardPlain (IVector x, IVector stepSizes, IVector gradient)
| Calculates numerical derivatives (gradient) of this function. Forward difference formula is normally used. More...
void | NumericalGradientForward (IVector x, IVector stepSizes, ref IVector gradient)
| Calculates numerical derivatives (gradient) of this function. Forward difference formula is normally used. More...
void | NumericalGradientForward (IVector x, double stepSize, ref IVector gradient)
| Calculates numerical derivatives (gradient) of this function. Forward difference formula is used. More...
virtual void | NumericalGradientCentralPlain (IVector x, IVector stepSizes, IVector gradient)
| Calculates numerical derivatives (gradient) of this function. Forward difference formula is normally used. More...
void | NumericalGradientCentral (IVector x, IVector stepSizes, ref IVector gradient)
| Calculates numerical derivatives (gradient) of this function. Forward difference formula is normally used. More...
void | NumericalGradientCentral (IVector x, double stepSize, ref IVector gradient)
| Calculates numerical derivatives (gradient) of this function. Forward difference formula is normally used. More...
virtual void | NumericalHessianForwardPlain (IVector x, IVector stepSizes, IVector aux, IMatrix hessian)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. WARNING: Dimensions of vector arguments must match. This function does not check for consistency of argument dimensions. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianForward (IVector x, IVector stepSizes, ref IVector aux, ref IMatrix hessian)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. REMARK: if auxiliary vector or result matrix don't have correct dimensions or they are not allocated, then allocation is performed first. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianForward (IVector x, double stepSize, ref IVector aux, ref IMatrix hessian)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. REMARK: if auxiliary vector or result matrix don't have correct dimensions or they are not allocated, then allocation is performed first. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianCentralPlain (IVector x, IVector stepSizes, IVector aux1, IVector aux2, IMatrix hessian)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. WARNING: Dimensions of vector arguments must match. This function does not check for consistency of argument dimensions. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianCentral (IVector x, IVector stepSizes, ref IVector aux1, ref IVector aux2, ref IMatrix hessian)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. REMARK: if auxiliary vector or result matrix don't have correct dimensions or they are not allocated, then allocation is performed first. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianCentral (IVector x, double stepSize, ref IVector aux1, ref IVector aux2, ref IMatrix hessian)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. REMARK: if auxiliary vector or result matrix don't have correct dimensions or they are not allocated, then allocation is performed first. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianCentralPlain (IVector x, IVector stepSizes, IVector aux1, IVector aux2, IMatrix hessian, bool useAnalyticalGradient)
| Calculates numerical second derivatives (Hessian) of this function by the central difference formula. WARNING: Dimensions of vector arguments must match. This function does not check for consistency of argument dimensions. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianCentral (IVector x, IVector stepSizes, ref IVector aux1, ref IVector aux2, ref IMatrix hessian, bool useAnalyticalGradient)
| Calculates numerical second derivatives (Hessian) of this function by the central difference formula. REMARK: if auxiliary vector or result matrix don't have correct dimensions or they are not allocated, then allocation is performed first. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
virtual void | NumericalHessianCentral (IVector x, double stepSize, ref IVector aux1, ref IVector aux2, ref IMatrix hessian, bool useAnalyticalGradient)
| Calculates numerical second derivatives (Hessian) of this function. Forward difference formula is normally used. REMARK: if auxiliary vector or result matrix don't have correct dimensions or they are not allocated, then allocation is performed first. REMARK: Vector x is changed during operation, but is set to initial value before function returns (unless an exception is thrown). More...
void | TestSpeed (IVector parameters, int numEvaluations, bool randomPerturbations, double relativePerturbationSize, bool calcValue, bool calcGradient, bool calcHessian, bool writeLastResult)
| Tests speed of evaluation of the current scalar function and writes results to the console. More...
void | TestGradient (IVector parameters, IVector stepSizes, int stepReductionFactor, int numStepReductions, bool checkNumerical, bool writeErrorComponents, bool writeGradientComponents)
| Tests the calculation of gradients of the current scalar function. More...
void | TestGradient (IVector parameters, IVector stepSizes, int stepReductionFactor, int numStepReductions, bool checkNumerical, bool writeErrorComponents, bool writeGradientComponents, bool useCentralDifference)
| Tests the calculation of gradients of the current scalar function. More...
void | TestHessian (IVector parameters, IVector stepSizes, int stepReductionFactor, int numStepReductions, bool checkNumerical, bool writeErrorComponents, bool writeHessianComponents)
| Tests the calculation of Hessians of the current scalar function. More...
void | TestHessian (IVector parameters, IVector stepSizes, int stepReductionFactor, int numStepReductions, bool checkNumerical, bool writeErrorComponents, bool writeHessianComponents, bool useCentralDifference)
| Tests the calculation of Hessians of the current scalar function. More...
void | Test (IVector from, IVector to, int numProbes, IVector stepSizes, double tolerance, bool testDerivatives, bool testSecondDerivatives, bool printDifferences, bool printResults)
| Performs numerical tests on the function, with output written to the console. Derivatives and second derivatives are tested and compared to numerical derivatives. More...
void | Test (IVector from, IVector to, int numProbes, IVector stepSizes, double tolerance)
| Performs numerical tests on the function, with output written to the console. Derivatives and second derivatives are tested and compared to numerical derivatives. This method tests first and second order derivatives, prints differences between analytical and numerical values to the console, and prints reports where absolute differences exceed rolerance. More...
void | Test (IVector from, IVector to, int numProbes, double stepSize, double tolerance, bool testDerivatives, bool testSecondDerivatives, bool printDifferences, bool printResults)
| Performs numerical tests on the function, with output written to the console. Derivatives and second derivatives are tested and compared to numerical derivatives. More...
void | Test (IVector from, IVector to, int numProbes, double stepSize, double tolerance)
| Performs numerical tests on the function, with output written to the console. Derivatives and second derivatives are tested and compared to numerical derivatives. More...

## Properties
override string | Name`[get]`
| Returns a short name of the function. More...
override string | Description`[get]`
| Returns a short description of the function. More...
override bool | ValueDefined`[get, protected set]`
| Tells whether the first derivative is defined for this function (by implementation, not mathematically) More...
override bool | GradientDefined`[get, protected set]`
| Tells whether the first derivative is defined for this function (by implementation, not mathematically) More...
override bool | HessianDefined`[get, protected set]`
| Tells whether the second derivative is defined for this function (by implementation, not mathematically) More...
Properties inherited from IG.Num.ScalarFunctionBase
virtual IAffineTransformation | Transformation`[get, set]`
| Transformation of parameters. Actual function is evaluated as some reference function evaluated at inverse affine-transformed parameters. More...
Properties inherited from IG.Num.ScalarFunctionUntransformedBase
virtual string | Name`[get, set]`
| Returns a short name of thecurrent function. More...
virtual string | Description`[get, set]`
| Returns a short description of the current function. More...
abstract bool | ValueDefined`[get, protected set]`
| Tells whether value of the function is defined by implementation. More...
abstract bool | GradientDefined`[get, protected set]`
| Tells whether the first derivative is defined for this function (by implementation, not mathematically) More...
abstract bool | HessianDefined`[get, protected set]`
| Tells whether the second derivative is defined for this function (by implementation, not mathematically) More...
Properties inherited from IG.Num.IScalarFunctionUntransformed
string | Name`[get]`
| Returns a short name of the function. More...
string | Description`[get]`
| Returns a short description of the function. More...
bool | ValueDefined`[get]`
| Tells whether value of the function is defined by implementation. More...
bool | GradientDefined`[get]`
| Tells whether the first derivative is defined for this function (by implementation, not mathematically) More...
bool | HessianDefined`[get]`
| Tells whether the second derivative is defined for this function (by implementation, not mathematically) More...
Properties inherited from IG.Num.IScalarFunction
IAffineTransformation | Transformation`[get, set]`
| Affine transformation of parameters. Actual function is evaluated as reference function evaluated at inverse affine transformed parameters. More...

## Additional Inherited Members
Protected Member Functions inherited from IG.Num.ScalarFunctionBase
| ScalarFunctionBase ()
| Default constructor for scalar functions of affine transformed parameters. Constructs untransformed reference function. More...
Protected Attributes inherited from IG.Num.ScalarFunctionBase
IVector | _refParam
IVector | _refGrad
IMatrix | _refHess
Protected Attributes inherited from IG.Num.ScalarFunctionUntransformedBase
string | _name
string | _description

## Detailed Description

Example quadratic polynomial in 2D. f(x,y) = 2*x^2 + y^2 + x*y + x + y + 10.

$A Igor Dec10;

## Constructor & Destructor Documentation

IG.Num.ScalarFunctionExamples.Quadratic2d.Quadratic2d | ( |  | ) |
| inline

Creates a new untransformed example quadratic polynomial in 2D.

IG.Num.ScalarFunctionExamples.Quadratic2d.Quadratic2d | ( | IAffineTransformation | transf | ) |
| inline

Creates a new transformed example quadratic polynomial in 2D. Actual function is identical to the reference function applied to inverse transformed parameters.

Parameters

  transf | Affine transformation that is applied to parameters. If null then the fuction is identical to the untransformed reference function.

## Member Function Documentation

override double IG.Num.ScalarFunctionExamples.Quadratic2d.ReferenceValue | ( | IVector | parameters | ) |
| inline virtual

Returns the value of this function at the specified parameter in the reference coordinate system.

Parameters

  parameters | Vector of parameters (in the REFERENCE system) where function is evaluated.

Implements IG.Num.ScalarFunctionBase.

override void IG.Num.ScalarFunctionExamples.Quadratic2d.ReferenceGradientPlain | ( | IVector | parameters,
|  | IVector | gradient
| ) |  |
| inline virtual

Calculates the first derivative (gradient) of this function at the specified parameter in the reference coordinate system.

Parameters

  parameters | Vector of parameters (in the REFERENCE system) where derivatives are evaluated.
  gradient | Vector where first derivatives (gradient) are stored.

Implements IG.Num.ScalarFunctionBase.

override void IG.Num.ScalarFunctionExamples.Quadratic2d.ReferenceHessianPlain | ( | IVector | parameters,
|  | IMatrix | hessian
| ) |  |
| inline virtual

Calculates the second derivative (Hessian) of this function at the specified parameters in the reference coordinate system.

Parameters

  parameters | Vector of parameters (in the REFERENCE system) where Hessian is evaluated.
  hessian | Matrix where second derivatives (Hessian) are stored.

Implements IG.Num.ScalarFunctionBase.

## Property Documentation

override string IG.Num.ScalarFunctionExamples.Quadratic2d.Name
| get

Returns a short name of the function.

override string IG.Num.ScalarFunctionExamples.Quadratic2d.Description
| get

Returns a short description of the function.

override bool IG.Num.ScalarFunctionExamples.Quadratic2d.ValueDefined
| get protected set

Tells whether the first derivative is defined for this function (by implementation, not mathematically)

override bool IG.Num.ScalarFunctionExamples.Quadratic2d.GradientDefined
| get protected set

Tells whether the first derivative is defined for this function (by implementation, not mathematically)

override bool IG.Num.ScalarFunctionExamples.Quadratic2d.HessianDefined
| get protected set

Tells whether the second derivative is defined for this function (by implementation, not mathematically)

The documentation for this class was generated from the following file:

- igbase/numeric/FunctionScalarExamples.cs